Child pages
  • S2-032
Skip to end of metadata
Go to start of metadata


Remote Code Execution can be performed via method: prefix when Dynamic Method Invocation is enabled.

Who should read this

All Struts 2 developers and users

Impact of vulnerability

Possible Remote Code Execution

Maximum security rating



Disable Dynamic Method Invocation if possible. Alternatively upgrade to Struts, Struts or Struts

Affected Software

Struts 2.3.20 - Struts Struts 2.3.28 (except and


Nike Zheng nike dot zheng at dbappsecurity dot com dot cn

CVE Identifier



It is possible to pass a malicious expression which can be used to execute arbitrary code on server side when Dynamic Method Invocation is enabled.


Disable Dynamic Method Invocation when possible or upgrade to Apache Struts versions, or

Backward compatibility

No issues expected when upgrading to Struts, and


Disable Dynamic Method Invocation or implement your own version of ActionMapper based on a source code of the recommended Apache Struts versions.

  • No labels